#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "elements.h"

static ELEM *alloc(void);

static ELEM *alloc(void)
{
	ELEM *p;
	
	if ((p = malloc(sizeof(ELEM))) == NULL) {
		printf("Allocation error\n");
		exit(1);
	}
		
	return p;
}

ELEM *addnode(ELEM *listp, char *s)
{
	ELEM *p, *newp;
	
	newp = alloc();	
	
	strcpy(newp->name, s);
	newp->next = NULL;	
	
	if (listp == NULL)
		return newp;	
	
	for (p = listp; p->next != NULL; p = p->next)		
		;
		
	p->next = newp;  
	
	return listp;
}
 
 void print(ELEM *p)
 {
	int n = 0;	
	
	while (p != NULL) {
		printf("%s%s", n > 0 ? ", " : "", p->name);
		p = p->next;
		n++;
	}	 
	printf("\n\n");
}

int find(char *s, ELEM *p)
{
	while (p != NULL) {
		if (strcmp(s, p->name) == 0)
			return 1;
		p = p->next;
	}
	return 0; 
}

ELEM *sortlist(ELEM *oldl)
{
	struct elem head;
	
	ELEM *newl, *n, *t, *u;
	
	newl = &head; 
	newl->next = NULL;
	
	if (oldl == NULL)
		return NULL;	
	
	for (t = oldl; t != NULL; t = u) {
		u = t->next;
		for (n = newl; n->next != NULL; n = n->next)			
			if (strcmp(n->next->name, t->name) > 0) 
				break;
		t->next = n->next;
		n->next = t;
	}
	
	return newl->next;
}

void freelist(ELEM *p)
{
	ELEM *next;
	
	while (p != NULL) {
		next = p->next;	
		free(p);
		p = next;
	}
}
